<?xml version="1.0" encoding="GBK" ?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
  <xsl:param name="filename"/>
  <xsl:param name="generatedate"/>
  <xsl:output method="text"/>
  <xsl:strip-space elements="*"/>
  <!-- Root template -->
  <xsl:template match="page">
    <!--package-->
    <xsl:if test="@packagename!=''">
    <xsl:text>package </xsl:text>
    <xsl:value-of select="@packagename"></xsl:value-of>
    <xsl:text>;</xsl:text>
    </xsl:if>
    import com.panda.report.engine.*;
    import javax.annotation.*;
    
    <!--public class-->
    <xsl:text>public abstract class Abstract</xsl:text>
    <xsl:value-of select="@classname"></xsl:value-of>
    <xsl:text> extends AbstractReport {</xsl:text>
    
    <!--declaration variable-->
    <xsl:apply-templates select="section/*"></xsl:apply-templates>
    <xsl:call-template name="generatevar"/>
    
    <!--Constructor-->
    @Generated(value={"Stub Compiler:OoReport","Version:1.0W"},
    comments="Generated By ReportStubCompiler",date="<xsl:value-of select="$generatedate"/>")
    public Abstract<xsl:value-of select="@classname"></xsl:value-of>(){    
        super("<xsl:value-of select="$filename"/>");
    }
    
    public abstract boolean hasMoreData();

    <!--Generating Sections-->
    <xsl:apply-templates select="section"/>
    

    <xsl:text>}</xsl:text>
    
  </xsl:template>
  
  <!--process sections-->
  <xsl:template match="section">
    <xsl:choose>
        <xsl:when test="@classname='com.panda.report.widget.designtime.DesignTimeReportHeaderSectionWidget'">
    public abstract void startReport(PrintSection section);
        </xsl:when>
        <xsl:when test="@classname='com.panda.report.widget.designtime.DesignTimePageHeaderSectionWidget'">
    public abstract void startPage(PrintSection section);
        </xsl:when>
        <xsl:when test="@classname='com.panda.report.widget.designtime.DesignTimeDetailSectionWidget'">
    public abstract void processDetail(PrintSection section);
        </xsl:when>
        <xsl:when test="@classname='com.panda.report.widget.designtime.DesignTimePageFooterSectionWidget'">
    public abstract void endPage(PrintSection section);
        </xsl:when>
        <xsl:when test="@classname='com.panda.report.widget.designtime.DesignTimeReportFooterSectionWidget'">
    public abstract void endReport(PrintSection section);
        </xsl:when>
        <xsl:when test="@classname='com.panda.report.widget.designtime.DesignTimeGroupHeaderSectionWidget'">
    public abstract void groupheader_<xsl:value-of select="@id"></xsl:value-of>(PrintSection section);
        </xsl:when>
        <xsl:when test="@classname='com.panda.report.widget.designtime.DesignTimeGroupFooterSectionWidget'">
    public abstract void groupfooter_<xsl:value-of select="@id"></xsl:value-of>(PrintSection section);
        </xsl:when>
        <xsl:otherwise></xsl:otherwise>
    </xsl:choose>
  </xsl:template>
    
  <xsl:template match="section/*">
    <xsl:if test="starts-with(@id,'CELL')=false()">
        <xsl:if test="@id!=''">
    public PrintField <xsl:value-of select="@id"></xsl:value-of>=null;
        </xsl:if>
    </xsl:if>
  </xsl:template>

  <xsl:template name="generatevar">
  <xsl:for-each select="section[@classname = 'com.panda.report.widget.designtime.DesignTimeGroupHeaderSectionWidget']"> 
        <xsl:if test="@datafield!=''">
    public PrintField <xsl:value-of select="@datafield"></xsl:value-of>=null;
        </xsl:if>	
  </xsl:for-each>
  </xsl:template>
</xsl:stylesheet>