<?xml version="1.0" encoding="GBK" ?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
  <xsl:param name="filename"/>
  <xsl:param name="generatedate"/>
  <xsl:output method="text"/>
  <xsl:strip-space elements="*"/>
  <!-- Root template -->
  <xsl:template match="page">
    <!--package-->
    <xsl:if test="@packagename!=''">
    <xsl:text>package </xsl:text>
    <xsl:value-of select="@packagename"></xsl:value-of>
    <xsl:text>;</xsl:text>
    </xsl:if>
    import com.panda.report.engine.*;
    import javax.annotation.*;
    
    <!--public class-->
    <xsl:text>public class </xsl:text>
    <xsl:value-of select="@classname"></xsl:value-of>
    <xsl:text> extends Abstract</xsl:text><xsl:value-of select="@classname"></xsl:value-of><xsl:text> {</xsl:text>
    
    /*Start Generating Sample Code.*/
    private int i = 0;            
    /*End Generating Sample Code.*/
    <!--declaration variable-->
    
    //Fields From Report Start(Defined In Base Class)
    <xsl:apply-templates select="section/*"></xsl:apply-templates>
    <xsl:call-template name="generatevar"/>
    //Fields From Report End

    <!--Constructor-->
    @Generated(value={"Stub Compiler:OoReport","Version:1.0W"},
    comments="Generated By ReportStubCompiler",date="<xsl:value-of select="$generatedate"/>")
    public <xsl:value-of select="@classname"></xsl:value-of>(){    
        super();
    }
    
    public boolean hasMoreData() {
    /*Start Generating Sample Code.*/
        if (i&lt;20){
                i++;
                return true;
        } else {
                return false;
        }
    /*End Generating Sample Code.*/
    }

    <!--Generating Sections-->
    <xsl:apply-templates select="section"/>
    
    <!--Main-->
    public static final void main(String[] argv){
        (new <xsl:value-of select="@classname"></xsl:value-of>()).printPreview();
    }
    <xsl:text>}</xsl:text>
    
  </xsl:template>
  
  <!--process sections-->
  <xsl:template match="section">
    <xsl:choose>
        <xsl:when test="@classname='com.panda.report.widget.designtime.DesignTimeReportHeaderSectionWidget'">
    public void startReport(PrintSection section){
    <xsl:call-template name="processSection"/>
    }
        </xsl:when>
        <xsl:when test="@classname='com.panda.report.widget.designtime.DesignTimePageHeaderSectionWidget'">
    public void startPage(PrintSection section){
    <xsl:call-template name="processSection"/>
    }
        </xsl:when>
        <xsl:when test="@classname='com.panda.report.widget.designtime.DesignTimeDetailSectionWidget'">
    public void processDetail(PrintSection section){
    <xsl:call-template name="processSection"/>
    }
        </xsl:when>
        <xsl:when test="@classname='com.panda.report.widget.designtime.DesignTimePageFooterSectionWidget'">
    public void endPage(PrintSection section){
    <xsl:call-template name="processSection"/>
    }
        </xsl:when>
        <xsl:when test="@classname='com.panda.report.widget.designtime.DesignTimeReportFooterSectionWidget'">
    public void endReport(PrintSection section){
    <xsl:call-template name="processSection"/>
    }
        </xsl:when>
        <xsl:when test="@classname='com.panda.report.widget.designtime.DesignTimeGroupHeaderSectionWidget'">
    public void groupheader_<xsl:value-of select="@id"></xsl:value-of>(PrintSection section){
    <xsl:call-template name="processSection"/>
    }
        </xsl:when>
        <xsl:when test="@classname='com.panda.report.widget.designtime.DesignTimeGroupFooterSectionWidget'">
    public void groupfooter_<xsl:value-of select="@id"></xsl:value-of>(PrintSection section){
    <xsl:call-template name="processSection"/><br/>
    }
        </xsl:when>
        <xsl:otherwise></xsl:otherwise>
    </xsl:choose>
  </xsl:template>
  
  <xsl:template name="processSection">
    //Set  the cell style at here
  </xsl:template>
  
  <xsl:template match="section/*">
    <xsl:if test="starts-with(@id,'CELL')=false()">
        <xsl:if test="@id!=''">
    //public PrintField <xsl:value-of select="@id"></xsl:value-of>=null;    
        </xsl:if>
    </xsl:if>
  </xsl:template>

  <xsl:template name="generatevar">
  <xsl:for-each select="section[@classname = 'com.panda.report.widget.designtime.DesignTimeGroupHeaderSectionWidget']"> 
        <xsl:if test="@datafield!=''">
    //public PrintField <xsl:value-of select="@datafield"></xsl:value-of>=null;
        </xsl:if>	
  </xsl:for-each>
  </xsl:template>
</xsl:stylesheet>
